/**
 * @require : none
 * @author : lu.hua
 * @date : 2011-09-09
 * @description : this is a new file 
 */

TIMEOUT = 120;
ACCOUNT = '';
PASSWORD = '';

if (phantom.args.length == 0)
{
    console.log('date needed');
    phantom.exit()
}

var SaleDate = phantom.args[0];

setTimeout(function(){phantom.exit()}, TIMEOUT * 1000);

var page = new WebPage();
page.onConsoleMessage = function(msg){console.log(msg);};
page.onResourceRequested = function(request)
{
    //console.log('Request ' + JSON.stringify(request, undefined, 4));
};

page.open('https://itunesconnect.apple.com/WebObjects/iTunesConnect.woa', function(stat)
{
    var currentUrl = page.evaluate(function()
    {
        return window.location.href;
    });

    console.log('current url:' + currentUrl);

    if (currentUrl == 'https://itunesconnect.apple.com/WebObjects/iTunesConnect.woa')
    { 
        //console.log('login page loaded');
        page.evaluate(new Function("my_account = '" + ACCOUNT + "';\nmy_password = '" + PASSWORD + "';\n"));

        page.evaluate(function()
        {
            document.getElementById('accountname').value = my_account;
            document.getElementById('accountpassword').value = my_password;
            document.getElementById('accountpassword').form.submit();
        });
    }
    else if (currentUrl.indexOf('https://itunesconnect.apple.com/WebObjects/iTunesConnect.woa/wo/') === 0)
    {
        console.log('login success');
        page.evaluate(function()
        {
            window.location.href = 'https://reportingitc.apple.com/';
        });

    }
    else if (currentUrl == 'https://reportingitc.apple.com/subdashboard.faces')
    {
        console.log('report page loaded');
        
        page.evaluate(new Function("DianDianSaleDate = '" + SaleDate + "';"));
        var optionFinded = page.evaluate(function()
        {
            var select = document.getElementById('theForm:datePickerSourceSelectElement');
            var options = select.getElementsByTagName('option');
            var optionFinded = false,option;
            for (var i = 0; i < options.length; i++) 
            {
                option = options[i];
                if (option.value == DianDianSaleDate)
                {
                    option.selected = 'selected';
                    optionFinded = true;
                    select.onchange();
                }
            }
            return optionFinded;
        });
        
        var isLoaded = function()
        {
            return page.evaluate(function()
            {
                var el = document.getElementById('click-limiter');
                if (!el) return true;
                return (el.style.display == 'none');
            });
        };
       
        function getReport()
        {
            var checkTimer = null;
            var report = null;
            checkTimer = setInterval(function()
            {
                console.log('check if report loaded');
                if (isLoaded())
                {
                    clearInterval(checkTimer);
                    console.log('report loaded');
                    report = page.evaluate(function()
                    {
                        var rt = '';
                        var table = document.getElementById('theForm:topProductsTable1');
                        var rows = table.getElementsByTagName('tr');
                        var tr,tds,name,count;
                        for (var i = 0; i < rows.length; i++)
                        {
                            tr = rows[i];
                            tds = tr.getElementsByTagName('td'); 
                            name = tds[0].getElementsByTagName('span')[1].innerHTML; 
                            count = tds[1].innerHTML; 
                            if (!/^\s*$/.test(name))
                            {
                                rt += 'REPORT:\t' + name + '\t' + count + '\n';
                            }
                        }

                        return rt;
                    });
                    report && console.log(report);
                    phantom.exit()
                }
            }, 1000);
        }

        if (!optionFinded)
        {
            console.log("can't get sale of date" + SaleDate)
            phantom.exit()
        }
        else
        {
            setTimeout(getReport, 500);
        }
    }
});
